(************** Content-type: application/mathematica **************
                     CreatedBy='Mathematica 5.2'

                    Mathematica-Compatible Notebook

This notebook can be used with any Mathematica-compatible
application, such as Mathematica, MathReader or Publicon. The data
for the notebook starts with the line containing stars above.

To get the notebook into a Mathematica-compatible application, do
one of the following:

* Save the data starting with the line of stars above into a file
  with a name ending in .nb, then open the file inside the
  application;

* Copy the data starting with the line of stars above to the
  clipboard, then use the Paste menu command inside the application.

Data for notebooks contains only printable 7-bit ASCII and can be
sent directly in email or through ftp in text mode.  Newlines can be
CR, LF or CRLF (Unix, Macintosh or MS-DOS style).

NOTE: If you modify the data for this notebook not in a Mathematica-
compatible application, you must delete the line below containing
the word CacheID, otherwise Mathematica-compatible applications may
try to use invalid cache data.

For more information on notebooks and Mathematica-compatible 
applications, contact Wolfram Research:
  web: http://www.wolfram.com
  email: info@wolfram.com
  phone: +1-217-398-0700 (U.S.)

Notebook reader applications are available free of charge from 
Wolfram Research.
*******************************************************************)

(*CacheID: 232*)


(*NotebookFileLineBreakTest
NotebookFileLineBreakTest*)
(*NotebookOptionsPosition[      4798,        152]*)
(*NotebookOutlinePosition[      5466,        175]*)
(*  CellTagsIndexPosition[      5422,        171]*)
(*WindowFrame->Normal*)



Notebook[{

Cell[CellGroupData[{
Cell["Dagger", "ObjectName"],

Cell[TextData[{
  "\[FilledSmallSquare] ",
  StyleBox["Dagger",
    FontFamily->"Courier"],
  " is an option for several ",
  StyleBox["DefType",
    FontFamily->"Courier"],
  " commands specifying how the defined objects behave under complex \
conjugation.\n\[FilledSmallSquare] ",
  StyleBox["Dagger",
    FontFamily->"Courier"],
  "[",
  StyleBox["expr",
    FontSlant->"Italic"],
  "] returns the complex conjugate of ",
  StyleBox["expr",
    FontSlant->"Italic"],
  "."
}], "Usage"],

Cell[TextData[{
  "\[FilledSmallSquare] Possible values for the option ",
  StyleBox["Dagger",
    FontFamily->"Courier"],
  " are ",
  StyleBox[ButtonBox["Real",
    ButtonData:>{"Real.nb", None},
    ButtonStyle->"Hyperlink"],
    FontFamily->"Courier"],
  ", ",
  StyleBox[ButtonBox["Imaginary",
    ButtonData:>{"Imaginary.nb", None},
    ButtonStyle->"Hyperlink"],
    FontFamily->"Courier"],
  ", ",
  StyleBox[ButtonBox["Complex",
    ButtonData:>{"Complex.nb", None},
    ButtonStyle->"Hyperlink"],
    FontFamily->"Courier"],
  " and ",
  StyleBox[ButtonBox["Hermitian",
    ButtonData:>{"Hermitian.nb", None},
    ButtonStyle->"Hyperlink"],
    FontFamily->"Courier"],
  ".\n\[FilledSmallSquare] The head ",
  StyleBox["Dagger",
    FontFamily->"Courier"],
  " is a (not linear) inert-head. It remains as the head of an expression \
when no further evaluation is possible. The only exception are symbols, for \
which we always expect evaluation (an error is thrown otherwise).\n\
\[FilledSmallSquare] Use ",
  StyleBox[ButtonBox["DaggerIndex",
    ButtonData:>{"DaggerIndex.nb", None},
    ButtonStyle->"Hyperlink"],
    FontFamily->"Courier"],
  " on indices.\n\[FilledSmallSquare] On numeric expressions ",
  StyleBox["Dagger",
    FontFamily->"Courier"],
  " becomes ",
  StyleBox["Conjugate",
    FontFamily->"Courier"],
  ".\n\[FilledSmallSquare] There is no proper treatment of determinations: ",
  StyleBox["Dagger",
    FontFamily->"Courier"],
  " on a product is the product of the ",
  StyleBox["Dagger",
    FontFamily->"Courier"],
  " of the terms.\n\[FilledSmallSquare] See: ",
  ButtonBox["Section 5.6",
    ButtonData:>{
      FrontEnd`FileName[ {
        ParentDirectory[ ]}, "xTensorRefGuide.nb", CharacterEncoding -> 
        "iso8859-1"], "Complex conjugation"},
    ButtonStyle->"Hyperlink"],
  ".\n\[FilledSmallSquare] See also: ",
  StyleBox[ButtonBox["$DaggerCharacter",
    ButtonData:>{"$DaggerCharacter.nb", None},
    ButtonStyle->"Hyperlink"],
    FontFamily->"Courier"],
  ", ",
  StyleBox[ButtonBox["DaggerQ",
    ButtonData:>{"DaggerQ.nb", None},
    ButtonStyle->"Hyperlink"],
    FontFamily->"Courier"],
  ", ",
  StyleBox[ButtonBox["TransposeDagger",
    ButtonData:>{"TransposeDagger.nb", None},
    ButtonStyle->"Hyperlink"],
    FontFamily->"Courier"],
  ".\n\[FilledSmallSquare] New in version 0.\n\[FilledSmallSquare] Last \
update: 26-X-2007 for version 0.9.3 of ",
  StyleBox["xTensor`",
    FontFamily->"Courier"],
  "."
}], "Text"]
}, Open  ]]
},
FrontEndVersion->"5.2 for X",
ScreenRectangle->{{0, 1280}, {0, 1024}},
WindowSize->{520, 600},
WindowMargins->{{114, Automatic}, {Automatic, 0}},
StyleDefinitions -> "HelpBrowser.nb"
]

(*******************************************************************
Cached data follows.  If you edit this Notebook file directly, not
using Mathematica, you must remove the line containing CacheID at
the top of  the file.  The cache data will then be recreated when
you save this file from within Mathematica.
*******************************************************************)

(*CellTagsOutline
CellTagsIndex->{}
*)

(*CellTagsIndex
CellTagsIndex->{}
*)

(*NotebookFileOutline
Notebook[{

Cell[CellGroupData[{
Cell[1776, 53, 28, 0, 38, "ObjectName"],
Cell[1807, 55, 488, 18, 70, "Usage"],
Cell[2298, 75, 2484, 74, 280, "Text"]
}, Open  ]]
}
]
*)



(*******************************************************************
End of Mathematica Notebook file.
*******************************************************************)

